from gnuradio import gr
from gnuradio.eng_notation import num_to_str, str_to_num
from gnuradio import usrp
from gnuradio import audio
from gnuradio import blks2
from gnuradio.eng_option import eng_option
from optparse import OptionParser
from usrpm import usrp_dbid
import math
import sys
import csv
import time

def my_top_block():
	
	frequency = 10e6
	
	sink = gr.file_sink(gr.sizeof_gr_complex,"10mhz1000random110709usrp.dat")
	
	##c2f = gr.complex_to_float()
	
	fg = gr.top_block()
		
	usrp_decim = 32	##2 megasamples per second

        u = usrp.source_c(nchan=1,decim_rate=usrp_decim)
	
        adc_rate = u.adc_rate()                    # 64 MS/s
	
        ##u.set_decim_rate(usrp_decim)
        usrp_rate = adc_rate / usrp_decim
	
        # we're using both daughterboard slots, thus subdev is a 2-tuple
	subdev_spec = (1, 0)
	
	subdev = usrp.selected_subdev(u, subdev_spec)
	
        print "Using RX d'board %s" % (subdev.side_and_name())
	
	#Set the mux
	##u.set_mux(usrp.determine_rx_mux_value(u, subdev_spec))
	u.set_mux(0x00000022)  ## 0000 0000 0000 0000 0000 0000 0011 0010
	
	g = subdev.gain_range()   ## gain range
        gain = float(g[0]+g[1])/2  ##mid point
        subdev.set_gain(gain)      ## set the gain
	
	u.tune(0,subdev,frequency)  ##DDC0, subdevice and frequency required
	
	fg.connect(u,sink)

	return fg

if __name__ == '__main__':
	topblock = my_top_block()
	topblock.start()
	time.sleep(3)
	topblock.stop()